#include "imports.inc"
#include "glFonts.inc"

//-----------------------------------------------------------------------------
// DEFINES
//-----------------------------------------------------------------------------
#define IMMEDIATE_MODE 0
#define DISPLAY_LIST   1
#define VERTEX_ARRAY   2

// A custom data structure for our interleaved vertex attributes
// The interleaved layout will be, GL_T2F_N3F_V3F
struct Vertex
{
    float tv,tu;
    float nz,ny,nx;
    float vz,vy,vx;
};


class CMars : CWindow
{
	HDC	      g_hDC;
	HGLRC     g_hRC;
	HWND      g_hWnd;
	float     g_fSpinX,g_fSpinY;
	GLuint    g_textureID;
	GLuint    g_sphereDList;
	bool      g_bRenderInWireFrame;
	GLuint    g_nCurrentMode;
	GLuint    g_nNumSphereVertices;
	GLfloat   g_fMarsSpin;
	bool      firstPass;
	bool      bMousing;
	bool      showhelp;
	POINT     ptLastMousePosit;
	POINT     ptCurrentMousePosit;
	int       g_nWindowWidth;
	int       g_nWindowHeight;
	Vertex   *g_pSphereVertices; // Points to Vertex Array
	GLuint    g_nPrecision;

	declare CMars() {g_nPrecision  = 100; memset(&g_hDC,0,&g_nPrecision-&g_hDC);}
	declare virtual OnCreate(),int;
	declare virtual OnDestroy();
	declare virtual OnKeyDown(unsigned int nChar, INT nRepCnt, unsigned int nFlags),int;
	declare virtual OnLButtonDown(int x,int y, int flags),int;
	declare virtual OnLButtonUp(int x,int y,int flags),int;
	declare virtual OnMouseMove(int x,int y,int flags),int;
	declare virtual OnTimer(int nIDEvent),int;
	declare virtual OnSize(int nType,int cx,int cy),int;
	declare virtual OnClose() {Destroy();}

	declare loadTexture();
	declare renderSphere( float cx, float cy, float cz, float r, int p );
	declare createSphereDisplayList();
	declare setVertData( int index,float tu, float tv, float nx, float ny, float nz, float vx, float vy, float vz );
	declare createSphereGeometry( float cx, float cy, float cz, float r, int p );
	declare render();
	declare doBenchmark();
	declare ToggleFullScreen();
}